( Address book )
( DATE Modified:							)
(	10/28/93	Changed all tag names to upper case to		)
(			match the DTD.					)
(	11/01/93	Changed approach to use cursor positioning      )

80 string name
32 string bphone
32 string aphone
32 string hphone
32 string fax
80 string title
80 string category
80 string company
80 string addr1
80 string addr2
80 string city
80 string st
16 string zip
4096 string note

65 right_margin !
0  left_margin !

: define_mark                   \ This should be a C function
  " </ENTRY>" 1+ marker 8 cmove
  ;

define_mark
forget define_mark

: <ADDRESS>
   hdr_w @ current_w !		\ Output to header window
   " The SGML-based Address Book" 1+ center
   chunk_w @ current_w !	\ Ouptput to main window from now on
\   mark_position 
   ;
: </ADDRESS> 
   0 seek_mark ;

: <ENTRY> 
   0 0 gotoxy			\ Go to top of main window
   cls ;			\ Clear main window
: </ENTRY> 
   mark_position
   win_ui ;

: <NAME> name read_into ;
: </NAME>
   1 1 gotoxy
   bold_on " Name:     " prints  bold_off
   name display  ;

: <BPHONE> bphone read_into ;
: </BPHONE> 
   45 1 gotoxy
   bold_on " B.Phone:  " prints bold_off
   bphone display ;

: <APHONE> aphone read_into ;
: </APHONE> 
   45 2 gotoxy
   bold_on " A.Phone:  " prints bold_off
   aphone display ;

: <HPHONE> hphone read_into ;
: </HPHONE> 
   45 3 gotoxy
   bold_on " H.Phone:  " prints bold_off
   hphone display ;

: <FAX> fax read_into ;
: </FAX> 
   45 4 gotoxy
   bold_on " Fax:      " prints bold_off
   fax display ;

: <TITLE> title read_into ;
: </TITLE> 
   1 3 gotoxy
   bold_on  " Title:    " prints bold_off
   title display ;

: <CATEGORY> category read_into ;
: </CATEGORY> 
   1 4 gotoxy
   bold_on " Category: " prints bold_off
   category display ;

: <COMPANY>   company read_into ;
: </COMPANY>
   1 6 gotoxy  
   bold_on " Company:  " prints bold_off
   company display ;

: <ADDR1>  addr1 read_into ;
: </ADDR1> 
   11 8 gotoxy
   addr1 display ;

: <ADDR2> addr2 read_into ;
: </ADDR2> 
   11 9 gotoxy
   addr2 display 
   ;

: <CITY>  city read_into ;
: </CITY> 
   11 10 gotoxy
   city display " , " prints ;

: <ST>  st read_into ;
: </ST> st display "   " prints ;

: <ZIP>  zip read_into ;
: </ZIP> zip display ;

: <NOTE>  note read_into ;
: </NOTE> 
   1 12 gotoxy
   bold_on " Note:     " prints bold_off
   10 left_margin !
   note display 
   0 left_margin !
   ;

sviewer
