( Address book - long printed version                                )

( This code removes trailing \n from fields. This needs to be fixed  )
( in S-Engine, and the code removed.                                 )

( This version prints an address book is 8.5"X5.5" size to fit       )
( a day timer or franklin planner. There are minor differences       )
( between this and the other versions all through the file - BEWARE! )

( S-Engine needs to be modified to properly handle wrapping etc.     )

( 11/04/03	Minor formatting changes & code cleanup.             )

variable fd.out

10 constant  <nl>

4096 string out.buf

80 string name
32 string bphone
32 string aphone
32 string hphone
32 string fax
80 string title
80 string category
80 string company
80 string addr1
80 string addr2
80 string city
80 string st
16 string zip
4096 string note

35 right_margin !
0 left_margin !

: clear		( address --- )
   0 swap !
   ;
: >here		( 'string --- 'here )
   here 20 0 fill
   count here swap cmove
   here
   ;
: strapp	( 'string ch --- )
   swap dup strlen + 		\ Calculate end addr of string
   dup 1+			\ Calculate end +1
   0 swap !			\ Add a null to make sure it is properly terminated
   c!				\ Append char to it
   ;
: un.newline		( 'string --- )
   dup strlen + 1- 		\ Calc address
   dup c@ <nl> =		\ Compare last char to newline
   if
     0 swap c!			\ yes, trash it
   else
     drop
   endif
   ;
: blank.out.buf
   out.buf "                                                                " 
     1+ strcpy drop
   ;
: output.line		( 'string --- )
   fd.out @ fputline  drop drop		\ output the string
   ;
: clear.fields		( --- )
   name clear      bphone clear 
   aphone clear    hphone clear 
   fax clear       title clear 
   category clear  company clear 
   addr1 clear     addr2 clear 
   city clear      st clear 
   zip clear       note clear 
   ;

: .so
   " .so hplj." 1+ output.line
   " .so macros.rof" 1+ output.line
   ;
: .rl
   out.buf " .rl " 1+ strcpy drop
   out.buf ascii " strapp
   out.buf "     L--l---l-----------------------------R" 1+ strcat drop
   out.buf ascii " strapp
   out.buf output.line
   ;
: setup.rof
   " .he /SGML Phone Book///" 1+ output.line
   " .nf" 1+ output.line
   " .pl 46" 1+ output.line
   " .fo //-#-//" 1+ output.line
\   " .bp 1" 1+ output.line
   ;

: <ADDRESS>
   ." The SGML-based Address Book" cr cr
   " address.rof" >here WRITE fopen
   fd.out !
   .so   .rl
   setup.rof
   clear.fields
   ;
: </ADDRESS> 
   fd.out @ fclose
   ;

: .string		( 'const 'string --- )
   dup strlen 0>
   if
      out.buf rot 1+
      strcpy drop
      out.buf swap strcat drop
      out.buf output.line
   else
      drop drop
   endif
   ;
: .name
   name strlen 0=
   if    ( There is no name field, use the company name )
      name company strcpy drop
      company clear
   endif
   out.buf " ^BName:      " 1+ strcpy drop
   out.buf name strcat drop
   out.buf " ^b" 1+ strcat drop
   out.buf output.line
   ;
: .company
   company strlen 0>
   if
      out.buf    " Company:   " 1+ strcpy drop
      out.buf company strcat drop
      out.buf output.line
      fd.out @ fcr drop
   endif
   ;
: .city
   city strlen 0>
   if
      out.buf "            " 1+ strcpy
      out.buf city strcat drop
      out.buf " , " 1+ strcat drop
      st strlen 0>
      if    out.buf st strcat drop      endif
      out.buf "   " 1+ strcat drop
      zip  strlen 0>
      if    out.buf zip strcat drop     endif
      out.buf output.line
   endif
   ;
: divide.entries
   out.buf "       ______________________ " 1+ strcpy drop
   out.buf output.line
   fd.out @ fcr drop
   ;
: <ENTRY>    ;
: </ENTRY> 
   blank.out.buf
   .name
   " B Phone:   " bphone   .string
   " H Phone:   " hphone   .string
   " A Phone:   " aphone   .string
   " Fax:       " fax      .string
   fd.out @ fcr drop
   " Title:     " title    .string
   " Category:  " category .string
   .company
   "            " addr1    .string
   "            " addr2    .string
   .city
   fd.out @ fcr drop
   " Note:      " note     .string
   divide.entries
   clear.fields
   ;

: <NAME>	name read_into    ;
: </NAME>	name un.newline   ;

: <BPHONE>	bphone read_into  ;
: </BPHONE>	bphone un.newline ;

: <APHONE>	aphone read_into  ;
: </APHONE>	aphone un.newline ;

: <HPHONE>	hphone read_into  ;
: </HPHONE>	hphone un.newline ;

: <FAX> 	fax read_into     ;
: </FAX>	fax un.newline    ;

: <TITLE>	title read_into   ;
: </TITLE>	title un.newline  ;

: <CATEGORY>	category read_into  ;
: </CATEGORY>	category un.newline ;

: <COMPANY>	company read_into   ;
: </COMPANY>	company un.newline  ;

: <ADDR1>	addr1 read_into     ;
: </ADDR1>	addr1 un.newline    ;

: <ADDR2>	addr2 read_into     ;
: </ADDR2>	addr2 un.newline    ;

: <CITY>	city read_into      ;
: </CITY>	city un.newline     ;

: <ST>		st read_into        ;
: </ST>		st un.newline       ;

: <ZIP>		zip read_into       ;
: </ZIP>	zip un.newline      ;

: <NOTE>	note read_into      ;
: </NOTE>	note un.newline     ;

\  sviewer

